;FASM was used to compile this
		use16
		org 100h
TIMERV          = 149       ;1193180Hz/TIMERV = FREQ OF INTR8, approx 8008 Hz
DSP_BASE	= 220h
DSP_RESET	= DSP_BASE+6
DSP_WRITE       = DSP_BASE+0CH

start:          call SB_RESET
                jc .end

                call INIT_SB
                call start_timer
.loop:          mov ah,1
                int 16h
                jz .loop

                xor ax,ax
                int 16h
                call stop_timer
                call EXIT_SB
.end:           int 20h

start_timer:    CLI                 ;SAVE/SET INTR8 VECTOR
                xor ax,ax
                push ds
                mov ds,ax
                mov eax,dword [8*4]
                MOV [cs:SAVE8INTR],eax
                mov word [8*4],intr8
                mov [8*4+2],cs
                pop ds
                MOV     AL,36H          ;SET TIMER HARDWARE
                OUT     43H,AL
                MOV     AX,TIMERV
                OUT     40H,AL
                MOV     AL,AH
                OUT     40H,AL
                STI
                RETN

stop_timer:     CLI                 ;SAVE/SET INTR8 VECTOR
                xor ax,ax
                mov ds,ax
                MOV eax,[cs:SAVE8INTR]
                mov [8*4],eax
                push cs
                pop ds
                MOV     AL,36H          ;RESTORE TIMER HARDWARE
                OUT     43H,AL
                XOR     AL,AL
                OUT     40H,AL
                OUT     40H,AL
                STI
                RETN

intr8:   inc [cs:timercnt]
         push ax
         push dx
         push si

         mov ah,10h
         call SB_WRITE

         mov si,[cs:soundidx]
         lodsb
         cmp si,musiclength
         jnz .c4

         mov si,music
.c4:     mov [cs:soundidx],si
         mov ah,al
         call SB_WRITE

         xor dx,dx
         mov ax,[cs:timercnt]
         mov si,(65536+TIMERV/2)/TIMERV
         div si
         or dx,dx
         pop si
         pop dx
         jz .c2

         MOV AL,20H
         OUT 20H,AL
         pop ax
         iret

.c2:     pop ax
         db  0eah       ;far jump
SAVE8INTR  DD 0

timercnt dw 0
soundidx dw music

SB_RESET:       MOV     DX,DSP_RESET
                MOV     AL,1
                OUT     DX,AL
                xor al,al
                out 43h,al
                in al,40h
                mov bl,al
                in al,40h
                mov bh,al
.L1:            xor al,al
                out 43h,al
                in al,40h
                mov cl,al
                in al,40h
                mov ch,al
                sub cx,bx
                neg cx
                CMP CX,3   ;approx 3.4 microsec
                JC .L1

                XOR     AX,AX
                OUT     DX,AL
                ADD     DL,8      ;gets DSP_READ = DSP_RESET+8
                mov cx,2000      ;the number of tries
.L2:            IN      AL,DX
                TEST    AL,80H
                JZ      .L2

                SUB     DL,4    ;gets DSP_DATA = DSP_READ-4
.L3:            IN      AL,DX
                dec cx
                JZ      .L4

                CMP     AL,0AAH
                JNZ     .L3

                clc
                RETN

.L4:            stc            ;no blaster at this port
                RETN

SB_WRITE:       MOV     DX,DSP_WRITE    ;AH->[DX]
.L1:            IN      AL,DX           ;USE AX,DX
                TEST    AL,80H
                JNZ     .L1

                MOV     AL,AH
                OUT     DX,AL
                RETN

INIT_SB:        MOV     AH,0D1H
                JMP     SB_WRITE

EXIT_SB:        MOV     AH,0D3H
                JMP     SB_WRITE

som:
file 'z8.wav'      ;place any mono wav-file here with 8008 Hz byte sample rate and length less than 62 KB
eom:
music = som+44     ;44 is the size of used wav-file header, it is not too important
musiclength     = eom-music
